<?php
namespace Teknisa\PED\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Ger00700ClienteFactory {
    #default service
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        #initializes default service
        $this->connection = $entityManager->getConnection();
    }

    public function checkPendencias($params){
        
        try {
            // $this->connection->beginTransaction();
            // $procedure = new StoredProcedure($this->connection, 'FN_CHECK_PENDENCIA'); //('FN_CHECK_PENDENCIA')
            // $procedure->addParam(new Param('P_CDCLIENTE', Param::PARAM_INPUT, $params['P_CDCLIENTE'] , Param::PARAM_TYPE_STR));
            // $procedure->execute(); //Invoca a função
            // $this->connection->commit(); 
            
            $this->connection->beginTransaction();
            
            $sql = "SELECT FN_CHECK_PENDENCIA( :P_CDCLIENTE, :P_CDFILIAL ) AS PENDENCIA FROM DUAL";

            $std = $this->connection->prepare($sql);
            
            $std->execute($params);
            
            $result = $std->fetch();
            
            $this->connection->commit();
            
            return $result;
            
        } catch (\Exception $e) {
          //  $response->setError(new Error("Error in call function. ". $e->getMessage(), 500));
            $this->connection->rollback();
            throw $e;

        }

            
            

    }


}