<?php

namespace Teknisa\PED\Modules\Expedicao\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DataSource\DataSet;

class Ger01100TransportadoraController extends \Teknisa\PED\Controllers\TeknisaCrud {

    protected $crudService;
    protected $dataSourceName = 'transport_completa';
    protected $dataSourceNameToSave = 'transport';
    protected $environment;
    protected $Ger01100TransportadoraService;

    public function __construct($crudService, $parameterBag, $environment,$Ger01100TransportadoraService) {
        parent::__construct($crudService, $parameterBag);
        $this->crudService = $crudService;
        $this->environment = $environment;
        $this->Ger01100TransportadoraService = $Ger01100TransportadoraService;
    }

    public function findTransportadora(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'transport_completa';
        parent::find($request,$response);
    }

    public function realizaConsultaBanco($conditions) {
        $filterCriteria = new FilterCriteria($this->dataSourceName,$conditions);
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->Ger01100TransportadoraService->buscar($newFilterCriteria);
        return $dataSet;
    }

    public function saveTransportadora(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "transport_completa";
        $this->dataSourceNameToSave = "transport";
        $row = $request->getRow();
        if($row['__is_new']){
            try {
                $this->Ger01100TransportadoraService->salvar($row);
            }catch (\Exception $e) {
                if(strstr($e->getMessage(), 'ORA-00001') !== false){
                    $response->setError(new Error("Impossível adicionar. Registro já existe.",500));
                }else{
                    $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
                }

            }
        }else{
            parent::save($request,$response);
        }
    }

    public function verificarParceiro(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'parcnegocio';
        parent::find($request,$response);
    }

    public function condicaoParceiro($row) {
        $conditions = array(
          array(
            "value" => $this->environment->getNrOrgTrab(),
            "operator" => "=",
            "columnName" => "NRORG"
          ),
          array(
            "value" => $row['NRINSJURTRAN'],
            "operator" => "=",
            "columnName" => "NRINSCRICAOPARC"
          )
        );
        return $conditions;
    }

}